<CsoundSynthesizer>
<CsOptions>
-o dac -d --messagelevel=2
</CsOptions>
; ==============================================
<CsInstruments>

sr	=	48000
ksmps	=	1
nchnls	=	2
0dbfs	=	1

#include "m_chorus.udo"

gaSound init 0 ; global input signal for the chorus

; Produce a tonal input signal
; p4 = iPch pitch class
instr Sound
	iFreq init cpspch(p4)

	; A simple envelope
	kEnv = linsegr(0, .2, .3, (p3 - .2), .3, .2, 0)
	aVco = vco2(kEnv, iFreq, 0)

	; Lowpass filter the oscillator for less harsh tones
	aLp = mvclpf3(aVco, iFreq*15, .05)
	
	; Add result to global sound
	gaSound += aLp
endin

; Add the chorus to the global sound
instr Chorus
	; Vary amount over time
	kAmount = linseg(0, 4, 0, 2, .2, 4, .2, 2, .4, 4, .4, 2, .6, 4, .6, 2, .8, 4, .8, 2, 1, 8.5, 1)
	kDryWet init .5

	; Pass the sound through the chorus and output the result
	aLeft, aRight m_chorus gaSound, kAmount, kDryWet
	outs(aLeft, aRight)
	gaSound = 0
endin

</CsInstruments>
; ==============================================
<CsScore>
i"Chorus" 0 38.5
; Create a few chords
i"Sound" 0 2 6.04
i. 0 2 7.11
i. 0 2 8.07
i. 2 2 6.02
i. . . 7.11
i. . . 8.06
i. 4 . 6.00
i. . . 7.11
i. . . 8.04
i. 6 . 5.11
i. . . 7.09
i. . 1 8.04
i. 7 . 8.03
i. 8 2 5.09
i. . . 8.00
i. . . 8.04
i. 10 . 5.07
i. . . 7.11
i. . . 8.04
i. 12 . 5.06
i. . . 7.09
i. . . 8.04
i. 14 . 5.06
i. . . 8.04
i. . 1 7.11
i. 15 . 7.10
i. 16 2 5.11
i. . . 7.06
i. . . 8.02
i. 18 . 5.09
i. . . 7.06
i. . . 8.01
i. 20 . 5.07
i. . . 7.11
i. . 1 7.06
i. 21 . 7.04
i. 22 2 5.06
i. . . 7.02
i. . . 7.09
i. 24 . 5.04
i. . . 7.00
i. . . 7.07
i. 26 . 5.02
i. . . 7.00
i. . . 7.06
i. 28 . 5.02
i. . . 6.11
i. . . 7.06
i. 30 . 5.00
i. . . 6.11
i. . . 7.04
i. 32 4 4.11
i. . . 6.11
i. . . 7.06
e
</CsScore>
</CsoundSynthesizer>
